﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using TDCG;

namespace Tso2Pmd
{
    public partial class Form2 : Form
    {
        Figure fig ;
        int check_flag = 0;
        List<int> verCount = new List<int>();
        List<string> opt;
        ClippingCheckList check;

        public Form2()
        {
            InitializeComponent();
        }

        public Form2(Figure fig, List<string> opt, ref ClippingCheckList check)
        {
            InitializeComponent();
            this.fig = fig;
            this.opt = opt;
            this.check = check;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            VerticesCount();
        }

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            // 省略される頂点数を計算
            int clip_verCount = 0;
            for (int i = 0; i < checkedListBox1.CheckedIndices.Count; i++)
            {
                clip_verCount += verCount[checkedListBox1.CheckedIndices[i]];
            }
            if (e.NewValue == CheckState.Checked)
            {
                clip_verCount += verCount[e.Index];
            }
            else
            {
                clip_verCount -= verCount[e.Index];
            }

            // 合計頂点数を表示
            label_VerCount.Text = (verCount.Sum() - clip_verCount).ToString();

            // 頂点数が上限を超えていたら文字を赤色にする
            if ((verCount.Sum() - clip_verCount) < 65535)
            {
                label_VerCount.ForeColor = Color.Black;
            }
            else
            {
                label_VerCount.ForeColor = Color.Red;
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                check_flag = 0;
                label1.Text = "カテゴリ - Material名 : 頂点数";
                VerticesCount();
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked == true)
            {
                check_flag = 1;
                label1.Text = "カテゴリ - Mesh名 : 頂点数";
                VerticesCount();
            }
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked == true)
            {
                check_flag = 2;
                label1.Text = "カテゴリ - Mesh名 -Sub_Mesh番号 (Material名) : 頂点数";
                VerticesCount();
            }
        }

        private void VerticesCount()
        {
            // 前回カウントした情報をクリア
            checkedListBox1.Items.Clear();
            verCount.Clear();

            // 頂点数をチェック
            int n_tso = 0;
            foreach (TSOFile tso in fig.TSOList)
            {
                switch (check_flag)
                {
                    case 0:
                        for (int script_num = 0; script_num < tso.sub_scripts.Length; script_num++)
                        {
                            int verCount_inScript = 0;

                            foreach (TSOFrame frame in tso.frames)
                            foreach (TSOMesh mesh in frame.meshes)
                            {
                                if (mesh.spec == script_num)
                                    verCount_inScript += mesh.vertices.Length;
                            }

                            checkedListBox1.Items.Add(
                                opt[n_tso] + " - " + tso.sub_scripts[script_num].Name
                                + " : " + verCount_inScript.ToString());
                            verCount.Add(verCount_inScript);
                        }
                        break;

                    case 1:
                        foreach (TSOFrame frame in tso.frames)
                        {
                            int verCount_inFrame = 0;

                            foreach (TSOMesh mesh in frame.meshes)
                            {
                                verCount_inFrame += mesh.vertices.Length;
                            }

                            checkedListBox1.Items.Add(
                                opt[n_tso] + " - " + frame.name
                                + " : " + verCount_inFrame.ToString());
                            verCount.Add(verCount_inFrame);
                        }
                        break;

                    case 2:
                        int verCount_inTso = 0;

                        foreach (TSOFrame frame in tso.frames)
                        {
                            int mesh_num = 0;

                            foreach (TSOMesh mesh in frame.meshes)
                            {
                                verCount_inTso += mesh.vertices.Length;

                                checkedListBox1.Items.Add(
                                    opt[n_tso] + " - " + frame.name + " -" + mesh_num.ToString()
                                    + " (" + tso.sub_scripts[mesh.spec].Name + ") : "
                                    + mesh.vertices.Length);
                                verCount.Add(mesh.vertices.Length);

                                mesh_num++;
                            }
                        }
                        break;
                }

                n_tso++;
            }

            RedisplayCount();
        }

        private void RedisplayCount()
        {
            // 合計頂点数を表示
            label_VerCount.Text = verCount.Sum().ToString();

            // 頂点数が上限を超えていたら文字を赤色にする
            if (verCount.Sum() < 65535)
            {
                label_VerCount.ForeColor = Color.Black;
            }
            else
            {
                label_VerCount.ForeColor = Color.Red;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            check.group_flag = check_flag;
            for (int i = 0; i < checkedListBox1.CheckedIndices.Count; i++)
            {
                check.checkList.Add(checkedListBox1.CheckedIndices[i]);
            }

            this.Close();
        }
    }
}
